package fr.irisa.cairn.jnimap.isl.tests.codegen;

import junit.framework.TestCase;

import org.junit.Ignore;

import fr.irisa.cairn.jnimap.isl.ISLASTBuild;
import fr.irisa.cairn.jnimap.isl.ISLASTNode;
import fr.irisa.cairn.jnimap.isl.ISLFactory;
import fr.irisa.cairn.jnimap.isl.ISLSet;
import fr.irisa.cairn.jnimap.isl.ISLUnionMap;

@Ignore
public class TestISLCodeGen extends TestCase {

	public static void testBasicSet() {
		String schedule = "[bound_data, v63, v60] -> { "
				+ "S10[1, i1, 0, i3] -> [1, i1, 0, i3, 0, 0, 0, 0, 0, 0, 0, 0] : bound_data >= 0 and 2i1 >= -2 - bound_data and 8i1 <= 3bound_data; "
				+ "S16[1, i1, 0, i3] -> [1, i1, 0, i3, 0, 0, 0, 0, 0, 0, 0, 0] : bound_data >= 0 and 2i1 >= -2 - bound_data and 8i1 <= 3bound_data; "
//				+ "S7[1, i1, 0, i3, 2, out_j1, out_j2] -> [1, i1, 0, i3, 4, 2, 2, out_j1, out_j2, 0, 0, 0] : out_j1 >= v63 and out_j1 <= 2bound_data + v63 and out_j2 <= 7 - bound_data + v60 + 8i1 and out_j2 >= -4 + v63 + v60 - 8i1 + 4i3 - out_j1 and out_j2 >= v60 and out_j2 <= -1 + v63 + v60 - 8i1 + 4i3 - out_j1 and out_j2 >= 4 - bound_data + v60 + 8i1 and out_j2 <= 2bound_data + v60; "
//				+ "S7[1, i1, 0, i3, 1, out_j1, out_j2] -> [1, i1, 0, i3, 4, 2, 1, out_j1, out_j2, 0, 0, 0] : out_j1 >= v63 and out_j1 <= 2bound_data + v63 and out_j2 <= 4 - v63 + v60 + 8i1 - 4i3 + out_j1 and out_j2 >= 4 + v60 + 8i1 and out_j2 >= v60 and out_j2 <= 7 + v60 + 8i1 and out_j2 >= 1 - v63 + v60 + 8i1 - 4i3 + out_j1 and out_j2 <= 2bound_data + v60; S7[1, i1, 0, i3, 0, out_j1, out_j2] -> [1, i1, 0, i3, 4, 2, 0, out_j1, out_j2, 0, 0, 0] : out_j1 >= v63 and out_j1 <= 2bound_data + v63 and 2out_j2 <= -4 - v63 + 2v60 - 8i1 + out_j1 and 3out_j2 <= 4 - v63 + 3v60 + 8i1 - 4i3 + out_j1 and out_j2 >= v60 and 3out_j2 >= 1 - v63 + 3v60 + 8i1 - 4i3 + out_j1 and 2out_j2 >= -7 - v63 + 2v60 - 8i1 + out_j1 and out_j2 <= 2bound_data + v60; "
//				+ "S5[1, i1, 0, 2i1, 1, bound_data + v63, bound_data + v60] -> [1, i1, 0, 2i1, 5, 0, 1, bound_data + v63, bound_data + v60, 0, 0, 0] : 8i1 >= -3 + bound_data and 8i1 <= bound_data and 8i1 <= -4 + 3bound_data; S17[1, i1, 0, i3, 2, bound_data + v63, bound_data + v60] -> [1, i1, 0, i3, 2, 0, 2, bound_data + v63, bound_data + v60, 0, 0, 0] : exists (e0, e1: e0 <= 3 and e0 >= 0 and e1 <= 3 and e1 >= 2 and e1 >= -16i1 + 4i3 + e0 and 3e1 >= -40i1 + 8i3 + 2e0 and 3e1 <= 2bound_data - 40i1 + 8i3 + 2e0 and e1 <= 2bound_data - 16i1 + 4i3 + e0); S17[1, i1, 0, i3, 1, bound_data + v63, bound_data + v60] -> [1, i1, 0, i3, 2, 0, 1, bound_data + v63, bound_data + v60, 0, 0, 0] : 8i1 >= 1 + bound_data and 8i1 <= 3bound_data and 4i3 >= -3 - bound_data + 16i1 and 4i3 <= bound_data + 16i1; S17[1, i1, 0, i3, 0, bound_data + v63, bound_data + v60] -> [1, i1, 0, i3, 2, 0, 0, bound_data + v63, bound_data + v60, 0, 0, 0] : bound_data >= 1 and i1 >= 0 and 4i1 <= bound_data and i3 >= 0 and 2i3 <= bound_data; S17[1, i1, 0, 4i1, 2, bound_data + v63, bound_data + v60] -> [1, i1, 0, 4i1, 2, 0, 2, bound_data + v63, bound_data + v60, 0, 0, 0] : i1 >= 0 and 4i1 <= bound_data; S4[1, T1, 0, T3, 3, 0, 0, 0, 0, 0, 0, 0] -> [1, T1, 0, T3, 3, 0, 0, 0, 0, 0, 0, 0] : 2T1 >= -2 - bound_data and 8T1 <= -4 + 3bound_data; "
//				+ "S6[1, i1, 0, i3] -> [1, i1, 0, i3, 0, 0, 0, 0, 0, 0, 0, 0] : bound_data >= 0 and 2i1 >= -2 - bound_data and 8i1 <= 3bound_data; S13[1, i1, 0, i3, 2, bound_data + v63, bound_data + v60] -> [1, i1, 0, i3, 1, 0, 2, bound_data + v63, bound_data + v60, 0, 0, 0] : exists (e0, e1: e0 <= 3 and e0 >= 0 and e1 <= 3 and e1 >= 2 and e1 >= -16i1 + 4i3 + e0 and 3e1 >= -40i1 + 8i3 + 2e0 and 3e1 <= 2bound_data - 40i1 + 8i3 + 2e0 and e1 <= 2bound_data - 16i1 + 4i3 + e0); S13[1, i1, 0, i3, 1, bound_data + v63, bound_data + v60] -> [1, i1, 0, i3, 1, 0, 1, bound_data + v63, bound_data + v60, 0, 0, 0] : 8i1 >= 1 + bound_data and 8i1 <= 3bound_data and 4i3 >= -3 - bound_data + 16i1 and 4i3 <= bound_data + 16i1; S13[1, i1, 0, i3, 0, bound_data + v63, bound_data + v60] -> [1, i1, 0, i3, 1, 0, 0, bound_data + v63, bound_data + v60, 0, 0, 0] : bound_data >= 1 and i1 >= 0 and 4i1 <= bound_data and i3 >= 0 and 2i3 <= bound_data; S13[1, i1, 0, 4i1, 2, bound_data + v63, bound_data + v60] -> [1, i1, 0, 4i1, 1, 0, 2, bound_data + v63, bound_data + v60, 0, 0, 0] : i1 >= 0 and 4i1 <= bound_data; S21[1, i1, 0, i3, 2, bound_data + v63, bound_data + v60] -> [1, i1, 0, i3, 2, 1, 2, bound_data + v63, bound_data + v60, 0, 0, 0] : exists (e0, e1: e0 <= 3 and e0 >= 0 and e1 <= 3 and e1 >= 2 and e1 >= -8 - 16i1 + 4i3 + e0 and 3e1 >= -20 - 40i1 + 8i3 + 2e0 and 3e1 <= -20 + 2bound_data - 40i1 + 8i3 + 2e0 and e1 <= -8 + 2bound_data - 16i1 + 4i3 + e0); S21[1, i1, 0, i3, 1, bound_data + v63, bound_data + v60] -> [1, i1, 0, i3, 2, 1, 1, bound_data + v63, bound_data + v60, 0, 0, 0] : 8i1 >= 1 + bound_data and 8i1 <= -4 + 3bound_data and 4i3 >= 5 - bound_data + 16i1 and 4i3 <= 8 + bound_data + 16i1; S21[1, i1, 0, i3, 0, bound_data + v63, bound_data + v60] -> [1, i1, 0, i3, 2, 1, 0, bound_data + v63, bound_data + v60, 0, 0, 0] : i1 >= 0 and 4i1 <= -2 + bound_data and i3 >= 0 and 2i3 <= bound_data; S21[1, i1, 0, 2 + 4i1, 2, bound_data + v63, bound_data + v60] -> [1, i1, 0, 2 + 4i1, 2, 1, 2, bound_data + v63, bound_data + v60, 0, 0, 0] : i1 >= 0 and 4i1 <= -2 + bound_data; S9[1, i1, 0, 2i1, 1, bound_data + v63, bound_data + v60] -> [1, i1, 0, 2i1, 4, 0, 1, bound_data + v63, bound_data + v60, 0, 0, 0] : 8i1 >= -3 + bound_data and 8i1 <= bound_data and 8i1 <= -4 + 3bound_data; S14[1, i1, 0, i3] -> [1, i1, 0, i3, 0, 0, 0, 0, 0, 0, 0, 0] : bound_data >= 0 and 2i1 >= -2 - bound_data and 8i1 <= 3bound_data; "
//				+ "S23[1, i1, 0, i3, 2, out_j1, out_j2] -> [1, i1, 0, i3, 5, 2, 2, out_j1, out_j2, 0, 0, 0] : out_j1 >= v63 and out_j1 <= 2bound_data + v63 and out_j2 <= 7 - bound_data + v60 + 8i1 and out_j2 >= -4 + v63 + v60 - 8i1 + 4i3 - out_j1 and out_j2 >= v60 and out_j2 <= -1 + v63 + v60 - 8i1 + 4i3 - out_j1 and out_j2 >= 4 - bound_data + v60 + 8i1 and out_j2 <= 2bound_data + v60; S23[1, i1, 0, i3, 1, out_j1, out_j2] -> [1, i1, 0, i3, 5, 2, 1, out_j1, out_j2, 0, 0, 0] : out_j1 >= v63 and out_j1 <= 2bound_data + v63 and out_j2 <= 4 - v63 + v60 + 8i1 - 4i3 + out_j1 and out_j2 >= 4 + v60 + 8i1 and out_j2 >= v60 and out_j2 <= 7 + v60 + 8i1 and out_j2 >= 1 - v63 + v60 + 8i1 - 4i3 + out_j1 and out_j2 <= 2bound_data + v60; S23[1, i1, 0, i3, 0, out_j1, out_j2] -> [1, i1, 0, i3, 5, 2, 0, out_j1, out_j2, 0, 0, 0] : out_j1 >= v63 and out_j1 <= 2bound_data + v63 and 2out_j2 <= -4 - v63 + 2v60 - 8i1 + out_j1 and 3out_j2 <= 4 - v63 + 3v60 + 8i1 - 4i3 + out_j1 and out_j2 >= v60 and 3out_j2 >= 1 - v63 + 3v60 + 8i1 - 4i3 + out_j1 and 2out_j2 >= -7 - v63 + 2v60 - 8i1 + out_j1 and out_j2 <= 2bound_data + v60; S20[1, i1, 0, i3] -> [1, i1, 0, i3, 0, 0, 0, 0, 0, 0, 0, 0] : bound_data >= 0 and 2i1 >= -2 - bound_data and 8i1 <= 3bound_data; S8[1, i1, 0, i3] -> [1, i1, 0, i3, 0, 0, 0, 0, 0, 0, 0, 0] : bound_data >= 0 and 2i1 >= -2 - bound_data and 8i1 <= 3bound_data; S24[1, i1, 0, i3] -> [1, i1, 0, i3, 0, 0, 0, 0, 0, 0, 0, 0] : bound_data >= 0 and 2i1 >= -2 - bound_data and 8i1 <= 3bound_data; S3[1, T1, 0, T3, 3, 0, 0, 0, 0, 0, 0, 0] -> [1, T1, 0, T3, 3, 0, 0, 0, 0, 0, 0, 0] : 2T1 >= -1 - bound_data and 8T1 <= 3bound_data; S12[1, i1, 0, i3] -> [1, i1, 0, i3, 0, 0, 0, 0, 0, 0, 0, 0] : bound_data >= 0 and 2i1 >= -2 - bound_data and 8i1 <= 3bound_data; S18[1, i1, 0, i3] -> [1, i1, 0, i3, 0, 0, 0, 0, 0, 0, 0, 0] : bound_data >= 0 and 2i1 >= -2 - bound_data and 8i1 <= 3bound_data; S19[1, i1, 0, i3, 2, bound_data + v63, bound_data + v60] -> [1, i1, 0, i3, 1, 1, 2, bound_data + v63, bound_data + v60, 0, 0, 0] : exists (e0, e1: e0 <= 3 and e0 >= 0 and e1 <= 3 and e1 >= 2 and e1 >= -8 - 16i1 + 4i3 + e0 and 3e1 >= -20 - 40i1 + 8i3 + 2e0 and 3e1 <= -20 + 2bound_data - 40i1 + 8i3 + 2e0 and e1 <= -8 + 2bound_data - 16i1 + 4i3 + e0); S19[1, i1, 0, i3, 1, bound_data + v63, bound_data + v60] -> [1, i1, 0, i3, 1, 1, 1, bound_data + v63, bound_data + v60, 0, 0, 0] : 8i1 >= 1 + bound_data and 8i1 <= -4 + 3bound_data and 4i3 >= 5 - bound_data + 16i1 and 4i3 <= 8 + bound_data + 16i1; "
//				+ "S19[1, i1, 0, i3, 0, bound_data + v63, bound_data + v60] -> [1, i1, 0, i3, 1, 1, 0, bound_data + v63, bound_data + v60, 0, 0, 0] : i1 >= 0 and 4i1 <= -2 + bound_data and i3 >= 0 and 2i3 <= bound_data; "
//				+ "S19[1, i1, 0, 2 + 4i1, 2, bound_data + v63, bound_data + v60] -> [1, i1, 0, 2 + 4i1, 1, 1, 2, bound_data + v63, bound_data + v60, 0, 0, 0] : i1 >= 0 and 4i1 <= -2 + bound_data; S11[1, i1, 0, i3, 2, out_j1, out_j2] -> [1, i1, 0, i3, 4, 1, 2, out_j1, out_j2, 0, 0, 0] : out_j1 >= v63 and out_j1 <= 2bound_data + v63 and out_j2 <= 3 - bound_data + v60 + 8i1 and out_j2 >= v63 + v60 - 8i1 + 4i3 - out_j1 and out_j2 >= v60 and out_j2 <= 3 + v63 + v60 - 8i1 + 4i3 - out_j1 and out_j2 >= -bound_data + v60 + 8i1 and out_j2 <= 2bound_data + v60; S11[1, i1, 0, i3, 1, out_j1, out_j2] -> [1, i1, 0, i3, 4, 1, 1, out_j1, out_j2, 0, 0, 0] : out_j1 >= v63 and out_j1 <= 2bound_data + v63 and out_j2 <= -v63 + v60 + 8i1 - 4i3 + out_j1 and out_j2 >= v60 + 8i1 and out_j2 >= v60 and out_j2 <= 3 + v60 + 8i1 and out_j2 >= -3 - v63 + v60 + 8i1 - 4i3 + out_j1 and out_j2 <= 2bound_data + v60; "
//				+ "S11[1, i1, 0, i3, 0, out_j1, out_j2] -> [1, i1, 0, i3, 4, 1, 0, out_j1, out_j2, 0, 0, 0] : out_j1 >= v63 and out_j1 <= 2bound_data + v63 and 2out_j2 <= -v63 + 2v60 - 8i1 + out_j1 and 3out_j2 <= -v63 + 3v60 + 8i1 - 4i3 + out_j1 and out_j2 >= v60 and 3out_j2 >= -3 - v63 + 3v60 + 8i1 - 4i3 + out_j1 and 2out_j2 >= -3 - v63 + 2v60 - 8i1 + out_j1 and out_j2 <= 2bound_data + v60 "
				+ "}";
		String params = "[bound_data, v63, v60] -> {  :  }";
		ISLSet paramsSet = ISLFactory.islSet(params);
		ISLUnionMap schedMap = ISLFactory.islUnionMap(schedule);

		ISLASTBuild build = ISLASTBuild.buildFromContext(paramsSet.copy());
		ISLASTNode root = ISLASTNode.buildFromSchedule(build, schedMap); 
	}
}
